%global Build_gcc3	1
%global upstream_release 2
%global momorel 6

Summary: A system integrity assessment tool
Name: tripwire
Version: 2.3.1
Release: %{momorel}m
License: GPL
Group:   Applications/System
Source0: http://download.sourceforge.net/tripwire/tripwire-%{version}-%{upstream_release}.tar.gz
NoSource: 0
Source1: tripwire.cron
Source2: tripwire.txt
Source3: tripwire.gif
Source4: twcfg.txt.in
Source5: twinstall.sh.in
Source6: twpol.txt.in
Source7: README.RPM
URL: http://www.tripwire.org/
Requires: sed, grep >= 2.3, gzip, tar, gawk
BuildRoot: %{_tmppath}/%{name}-%{version}-root

# Tripwire is NOT 64bit clean, nor endian clean, and only works properly
# on x86 architecture. The open source code doesn't seem to be maintained,
# so this is probably unlikely to change.  We exclude non x86 arches.
ExclusiveArch: %{ix86}

Patch0: tripwire-2.3.0-50-rfc822.patch
Patch1: tripwire-2.3.1-2-fhs.patch
Patch2: tripwire-2.3.1-gcc3.patch
Patch3: tripwire-jbj.patch
Patch4: tripwire-CAN-2004-0536.patch

%description
Tripwire is a very valuable security tool for Linux systems, if it is
installed to a clean system. Tripwire should be installed right after
the OS installation, and before you have connected your system to a
network (i.e., before any possibility exists that someone could alter
files on your system).

When Tripwire is initially set up, it creates a database that records
certain file information. Then when it is run, it compares a
designated set of files and directories to the information stored in
the database. Added or deleted files are flagged and reported, as are
any files that have changed from their previously recorded state in
the database. When Tripwire is run against system files on a regular
basis, any file changes will be spotted when Tripwire is run.
Tripwire will report the changes, which will give system
administrators a clue that they need to enact damage control measures
immediately if certain files have been altered.

After installing this package, run /etc/tripwire/twinstall.sh to
generate cryptographic keys and run tripwire --init to initialize the
database.

%prep
%setup -q -n %{name}-%{version}-%{upstream_release}
cp %{SOURCE2} quickstart.txt
cp %{SOURCE3} quickstart.gif

%patch0 -p1 -b .rfc822
%patch1 -p1 -b .fhs
%if %{Build_gcc3}
%patch2 -p1 -b .gcc3
%endif
%patch3 -p1 -b .jbj
%patch4 -p0 -b .CAN-2004-0536

%build
cd src
#make distclean

%if %{Build_gcc3}
rm -rf STLport*
touch STLport_r STLport_d
%endif

# Do not parallelize this with _smp_flags or -j
make release RPM_OPT_FLAGS="%{optflags}"

%install
[ %{buildroot} != / ] && rm -fr %{buildroot}

# Install the binaries.
mkdir -p %{buildroot}%{_sbindir}
install -m755 bin/*/siggen   %{buildroot}%{_sbindir}
install -m755 bin/*/tripwire %{buildroot}%{_sbindir}
install -m755 bin/*/twadmin  %{buildroot}%{_sbindir}
install -m755 bin/*/twprint  %{buildroot}%{_sbindir}

# Install the man pages.
mkdir -p %{buildroot}%{_mandir}/{man4,man5,man8}
install -m644 man/man4/*.4 %{buildroot}%{_mandir}/man4/
install -m644 man/man5/*.5 %{buildroot}%{_mandir}/man5/
install -m644 man/man8/*.8 %{buildroot}%{_mandir}/man8/

# Install configuration information.
mkdir -p %{buildroot}%{_sysconfdir}/tripwire

for infile in %{SOURCE4} %{SOURCE5} %{SOURCE6}; do
  outfile=%{buildroot}%{_sysconfdir}/tripwire/`basename $infile .in`
  cat $infile |\
  sed -e 's|@sbindir@|%{_sbindir}|g;s|@vardir@|%{_var}|g' > $outfile
done

# Create the reports directory.
install -d -m700 %{buildroot}%{_var}/lib/tripwire/report

# Install the cron job.
install -d -m755 %{buildroot}%{_sysconfdir}/cron.daily
install -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/cron.daily/tripwire-check

# Fix permissions on documentation files.
cp %{SOURCE7} .
chmod 644 README Release_Notes ChangeLog COPYING TRADEMARK quickstart.gif quickstart.txt README.RPM

%files
%defattr(-,root,root)
%doc README Release_Notes ChangeLog COPYING TRADEMARK quickstart.gif quickstart.txt README.RPM
%attr(0755,root,root) %dir %{_sysconfdir}/tripwire
%attr(0755,root,root) %{_sysconfdir}/tripwire/twinstall.sh
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/tripwire/twcfg.txt
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/tripwire/twpol.txt
%attr(0755,root,root) %config(noreplace) %{_sysconfdir}/cron.daily/tripwire-check
%attr(0755,root,root) %dir /var/lib/tripwire
%attr(0755,root,root) %dir /var/lib/tripwire/report
%attr(0644,root,root) %{_mandir}/*/*
%attr(0755,root,root) %{_sbindir}/*

%clean
[ %{buildroot} != / ] && rm -fr %{buildroot}

%changelog
* Tue Aug 03 2004 TAKAHASHI Tamotsu <tamo>
- (2.3.1-6m)
- [SECURITY] tripwire-CAN-2004-0536.patch
 http://www.securityfocus.com/archive/1/365036

* Mon Nov 24 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.3.1-5m)
- fix momorel for http://www.momonga-linux.org/a/head.html

* Fri Oct 10 2003 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.3.1-4m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Sun Dec 28 2002 Hideo TASHIRO <tashiron@jasmiso.org>
- (2.3.1-3m)
- apply tripwire-jbj.patch from rawhide

* Sat Nov  9 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.3.1-2m)
- apply gcc3 patch by default

* Sat Aug  8 2002 Hideo TASHIRO <tashiron@momonga-linux.org>
- (2.3.1-1m)
- First Build for Momonga Linux based on 2.3.1-10 from RedHat Linux
- replace emvironment variable with rpm macros
